package org.simantics.db.impl;

import org.eclipse.core.runtime.Plugin;
import org.osgi.framework.BundleContext;
import org.simantics.db.DevelopmentKeys;


public class Activator extends Plugin {

    // The plug-in ID
    public static final String BUNDLE_ID = "org.simantics.db.impl"; //$NON-NLS-1$

    // The shared instance
    private static Activator plugin;

    /**
     * The constructor
     */
    public Activator() {
    }

    /*
     * (non-Javadoc)
     * @see org.eclipse.ui.plugin.AbstractUIPlugin#start(org.osgi.framework.BundleContext)
     */
    @Override
    public void start(BundleContext context) throws Exception {
        super.start(context);
        plugin = this;

        // Make sure development debug key values are initialized if in development mode.
        DevelopmentKeys.initialize();
    }

    /*
     * (non-Javadoc)
     * @see org.eclipse.ui.plugin.AbstractUIPlugin#stop(org.osgi.framework.BundleContext)
     */
    @Override
    public void stop(BundleContext context) throws Exception {
        plugin = null;
        super.stop(context);
    }

    /**
     * Returns the shared instance
     *
     * @return the shared instance
     */
    public static Activator getDefault() {
        return plugin;
    }

}