package org.simantics.db.impl.query;

import org.simantics.db.exception.DatabaseException;

public class OrderedSetFactory extends QueryFactoryBase {

    @Override
    public CacheEntryBase readKeyAndValue(QueryDeserializer deserializer) throws DatabaseException {
        OrderedSet result = reference(deserializer);
        IntArray ia = IntArray.deserialize(deserializer);
        result.setResult(ia);
        result.setReady();
        return result;
    }
    
    @Override
    public <T extends CacheEntryBase> T reference(QueryDeserializer deserializer) throws DatabaseException {
        return (T)deserializer.readOrderedSet();
    }

}
